    
    #include <FS.h>
    #include <ESP8266WebServer.h>
    #include <WebSocketsServer.h>
    
    #include "SDL_Arduino_INA3221.h"

    #include "Timer.h"

    #include "DHTesp.h"

    Timer t;
    
    DHTesp dht;

    #define DHT11_PIN 12

    #define Ibat_addr                     (0x40)    // 1000001 (A0=A1=GND)
    #define Ibat_shunt_value  (0.00075)   // shunt resistor value of 0.00075 Ohm
    
    SDL_Arduino_INA3221 Ibat(Ibat_addr, Ibat_shunt_value);
    
    #define BAT1 1
    #define BAT2 2
    #define BAT3 3

    #define LEDcartemere D5

    String parametresbat;

    float Temperaturebat,RHbat;
    float Bat1V,Bat1I,Bat2V,Bat2I,Bat3V,Bat3I;

    float shuntvoltage1 = 0;
    float shuntvoltage2 = 0;
    float shuntvoltage3 = 0;

    uint8_t  socketNumber;

    char inChar = 0;

    ESP8266WebServer server(80); //Initialize le serveur sur Port 80
    WebSocketsServer webSocket(81); // Create a Websocket server

    #include "FonctionsACQ.h"
    #include "FonctionsWifi.h"
    
    void setup(void) 
    {

      Serial.begin(9600);
      
      SPIFFS.begin();
      WiFi.mode(WIFI_AP); //Programme le ESP8266-12E en AccessPoint
      WiFi.softAP("MonitoringBat", "ConnectBat"); // (SSID, password);

      server.on("/", HTTP_GET, []() {
      handleFileRead("/");
      });

      server.onNotFound([]() {                          // Handle when user requests a file that does not exist
        if (!handleFileRead(server.uri())) server.send(404, "text/plain", "FileNotFound");
      });

      webSocket.begin();                                // start webSocket server
      webSocket.onEvent(webSocketEvent);                // callback function

      server.begin(); // Démarrage du serveur http

      t.every(300, callACQ);
      
      dht.setup(DHT11_PIN, DHTesp::DHT11); // Connect DHT sensor to DHT PIN
      
      Temperaturebat = 0;
      RHbat = 0;
      Bat1V = 0;
      Bat1I = 0;
      Bat2V = 0;
      Bat2I = 0;
      Bat3V = 0;
      Bat3I = 0;

      
      pinMode(LED_BUILTIN, OUTPUT);
      pinMode(LEDcartemere, OUTPUT);
      digitalWrite(LED_BUILTIN, HIGH);
      digitalWrite(LEDcartemere, LOW);

      Serial.begin(9600);
      
      Ibat.begin();
      
    }
    
    void loop(void) 
    {

      digitalWrite(LED_BUILTIN, HIGH);
      
      t.update();

      delay(10);
      
      webSocket.sendTXT(socketNumber,parametresbat);
      
      server.handleClient();
      
      webSocket.loop();

    }
